#include <stdio.h>
#include <io.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/sem.h>
#include <sys/shm.h>
#include <fcntl.h>

#define FTOK_NAME "IPC_TEST"
#define BUF_SIZE  4096

int main(int argc, char* argv[]) {
    int fd;
    int i;
    key_t shm_key, sem_key;
    int shm_id, sem_id;
    int n_parcels;
    void* shm;
    struct sembuf sops[2];
    
    if (argc != 3) { 
	fprintf(stderr, "Usage: ipctest (producer|consumer) number-of-parcels");
	return 1;
    }
    memset(sops, 0, sizeof sops);
    n_parcels = atoi(argv[2]);

    fd = open(FTOK_NAME, O_WRONLY|O_CREAT, 0777);
    if (fd < 0) {
	fprintf(stderr, "Failed to create file\n");
	return 1;
    }

    shm_key = ftok(FTOK_NAME, 1);
    shm_id = shmget(shm_key, BUF_SIZE, IPC_CREAT|0777);
    if (shm_id < 0) { 
	perror("shmget failed");
	return 1;
    }
    shm = shmat(shm_id, NULL, 0);
    
    sem_key = ftok(FTOK_NAME, 2);
    sem_id = semget(sem_key, 2, IPC_CREAT|0777);
    if (sem_id < 0) { 
	perror("semget failed");
	return 1;
    }
    close(fd);
    if (strcmp(argv[1], "producer") == 0) { 
	for (i = 0; i < n_parcels; i++) {  
	    sops[0].sem_num = 0;
	    sops[0].sem_op  = 0;
	    sops[1].sem_num = 0;
	    sops[1].sem_op  = 1;
	    semop(sem_id, sops, 2);	    
	    sprintf((char*)shm, "Parcel %d from process %d\n", i, getpid());
	    sops[0].sem_num = 1;
	    sops[0].sem_op  = 1;
	    semop(sem_id, sops, 1);	    	    
	}
    } else { 
	for (i = 0; i < n_parcels; i++) {  
	    sops[0].sem_num = 1;
	    sops[0].sem_op  = -1;
	    semop(sem_id, sops, 1);
	    //printf((char*)shm);
	    sops[0].sem_num = 0;
	    sops[0].sem_op  = -1;
	    semop(sem_id, sops, 1);	    	    
	}
    }
    return 0;
}





